import com.haxepunk.HXP;
import com.haxepunk.Entity;
import com.haxepunk.graphics.*;
import Monster;


class AttackEffect extends Entity {
	public var vx:    Float;
	public var vy:    Float;
	public var life:  Int;
	public var tlife: Int;
	public var owner: Monster;
	public var data:  Attack;

	
	public function new(me:Monster, a:Attack, tx:Float, ty:Float) {
		super(me.x, me.y);
		owner = me;
		data = a;
		vx = tx - me.x;
		vy = ty - me.y;
		var d: Float = HXP.distance(vx, vy);
		vx/=d; vy/=d;
		
		x += vx * a.start;
		y += vy * a.start;

		vx *= a.speed;
		vy *= a.speed;

		if(a.speed>0) life = Std.int(a.range / a.speed);
		else life = 3;
		if(life<3) life = 3;
		tlife = 0;

		// gfx
		if(a.rotated) {
			var g:Image = new Image( "graphics/" + a.image );
			g.centerOrigin();
			g.angle = Math.atan2(vx, vy) * 180/Math.PI + 180;
			setHitboxTo(g);
			graphic = g;
		} else {
			var g:Stamp = new Stamp( "graphics/" + a.image );
			g.x = -g.width * 0.5;
			g.y = -g.height * 0.5;
			setHitboxTo(g);
			graphic = g;
		}
	}

	public override function update() {
		x += vx;
		y += vy;
		++tlife;

		// Collide
		if(life>0) {
			var list:Array<Entity> = new Array();
			collideInto("solid", x, y, list);
			for(e in list) {
				if(e!=owner && Std.is(e, Monster)) {
					var m:Monster = cast e;
					for(d in data.damage) m.damage(owner, d);
				}
				if(e!=owner) life = 0;
			}
		}
		
		// Remove
		if(--life<0 && tlife>6) world.remove(this);
	}



}



