import com.haxepunk.Entity;
import com.haxepunk.utils.*;
import com.haxepunk.graphics.*;
import Monster;

class Player extends Monster {
	var sprite: Spritemap;

	public function new(x:Int, y:Int) {
		var def:MonsterDef = new MonsterDef();
		def.name="player";
		def.speed = 3;
		def.health = 10;
		def.threat = 10;
		def.aggression = 0;
		def.range = 0;
		def.sense = 0;

		super(def, x,y);
		sprite = new Spritemap("graphics/player.png", 7, 11);
		graphic = sprite;
		sprite.centerOrigin();
		setHitboxTo(sprite);
		type = "solid";

		// Controls
		Input.define("up", [ Key.UP,    Key.W ]);
		Input.define("dn", [ Key.DOWN,  Key.S ]);
		Input.define("lt", [ Key.LEFT,  Key.A ]);
		Input.define("rt", [ Key.RIGHT, Key.D ]);

	}


	public override function update() {
		var dx:Int=0, dy:Int=0;

		if(Input.check("up")) --dy;
		if(Input.check("dn")) ++dy;
		if(Input.check("lt")) --dx;
		if(Input.check("rt")) ++dx;

		if(dx!=0 || dy!=0) {
			var sm:Float = dx!=0&&dy!=0? definition.speed*0.707: definition.speed;
			moveBy(dx*sm, dy*sm, "solid");
			if(dx>0)      sprite.frame = 2;
			else if(dx<0) sprite.frame = 3;
			if(dy>0)      sprite.frame = 0;
			else if(dy<0) sprite.frame = 1;
		}
	}

}

